function [mImageApprox mImageResized cCoefficients cIndex nCoefficients ...
    nZeroBlocks]  = ApproxMImageSCEIFS(mImage,blockHeight,blockWidth,...
   PSNR,maxIntensity,sDictionary,...
    algorithm)

% Wrapper around ApproxCellImageGreedy allows image matrix to be quickly
% approximated

% Block the matrix
% < < - - #
    [cImage mImageResized] = BlockMImage(mImage, blockHeight, blockWidth);
% - - > > #
  
% Uses the Sum Squared Error
%     SSE = PSNRToSSE( PSNR, numel(cImage{1}),maxIntensity);
    SSE = PSNRToSSE( PSNR, numel(cImage{1}), maxIntensity);
    
%     SSE = PSNRToBlockErrorNorm(PSNR,blockWidth*blockHeight,maxIntensity);
% - - > > #
    
    % Approximate the cell array
    % < < - - 
        [cImageApprox cCoefficients cIndex nCoefficients nZeroBlocks] = ...
            ApproxCellImageSCEIFS(cImage, SSE, sDictionary, algorithm);
    % - - > > 
    
%     end
% - - > > #

% Convert image cell back to a matrix
% < < - - #
    mImageApprox = cell2mat(cImageApprox);
% - - > > #