function  mDict = AtomMatrix(vAtom,nRows)

% Returns a matrix with nRows where the first column contains vAtom
% followed by zeros, and the remaining columns contain this atom shifted by
% one.
%   Quicker than calling toeplitz.

% Calculate the number of columns
% < < - - #
    support = size(vAtom,1);
    nColumns = nRows - support + 1;
% - - > > #

% Initialize the shifted matrix
% < < - - #
    nElements = nRows*nColumns;
    mDict = zeros(nRows,nColumns);
% - - > > #

% Matrix containing the linear indexes in mDict of vAtom
% < < - - #
    vAdd = 0:nRows+1:nElements-1;
    vInd = (1:support)';
    mInd = vInd(:,ones(nColumns,1)) + vAdd(ones(1,support),:);
% - - > > #

% Assigne vAtom to the above index positions in mDict
% < < - - #
    mDict(mInd) = vAtom(:,ones(1,nColumns));
% - - > > #