function [cImageFolded vNRows vIXBlockEnd imageEmbedded imageHost] = FoldApprox(sImageApprox...
    ,varargin)

% Forks to the appropriate folding routine

% RGB image processed seperatly as cells of coefficients
if iscell(sImageApprox.cCoefficients{1})
    
    PrintWithStars('FoldApproxRGB Routine Called');
    [cImageFolded imageEmbedded imageHost vIXBlockEnd] = FoldApproxRGB(...
        sImageApprox,varargin{:});
    
    % Required for spliting the images
    % < < - -
        [vNRows vTemp] = cellfun(@size, cImageFolded);
    % - - > > 
    
    % Temp
%     mImageFolded = cell2mat(cFoldedImage);
%     mImageEmbedded = cell2mat(cEmbeddedImage);
    
% RGB image processed Ml as 3 coefficients per index
elseif size(sImageApprox.cCoefficients{1},1) == 3
    
    PrintWithStars('FoldApproxMl Routine Called');
    [mImageFoldedRGB imageEmbedded sImageHost iXBlockEnd] = FoldApproxMl(...
        sImageApprox,varargin{:});    
        
    imageHost = sImageHost.mImageHost;
    
    cImageFolded = cell(1,3);
    
    % Place colour plains on top of each other
%         mImageFolded = [];
        for iColour = 1:3
%             mImageFolded = [mImageFolded; mImageFoldedRGB(:,:,iColour)];
            cImageFolded{iColour} = mImageFoldedRGB(:,:,iColour);
        end
    % - - > > #
%         mImageFolded = reshape(shiftdim(mImageFolded,1),[],sImageApprox.x);
        
    % Required for spliting the images - number of rows in each plain    
    %   Reshaped to 2D therefore nRows/3.
    % < < - -    
        vNRows = size(cImageFolded{1},1);
    % - - > >     
    
    % This will be the same for each colour plain.
        vIXBlockEnd = iXBlockEnd*ones(1,3);
    % - - > > #
        
    
% Grey scale image as 1 set of coefficients
elseif size(sImageApprox.cCoefficients{1},1) == 1   
    
    PrintWithStars('FoldApproxGrey Routine Called');
    [cImageFolded{1} imageEmbedded sImageHost vIXBlockEnd] = FoldApproxGrey(...
        sImageApprox,varargin{:});
    
    imageHost = sImageHost.mImageHost;
    % Required for spliting the images
    % < < - -
        vNRows = size(cImageFolded{1},1);
    % - - > >    
    
end