function [cImageFolded cVNCnPlain sRescale vNRows vILastXBlock] = FoldIndex(...
    sImageApprox,varargin)


% Forks to the appropriate index folding routine

% RGB image processed seperatly as cells of coefficients
if iscell(sImageApprox.cIndex{1})
    
    PrintWithStars('FoldIndexRGB Routine Called');
    [ cImageFolded, cVNCnPlain, sRescale, vILastXBlock ] = FoldIndexRGB(...
        sImageApprox,varargin{:});

    % Required for spliting the indexes
    % < < - -
        [vNRows vTemp] = cellfun(@size, cImageFolded);
    % - - > > 
    
    % Test
%     mImageFolded = cell2mat(cFoldedImage);
        
    
% RGB image processed Ml or grey level image
else %if sImageApprox.z == 3
    
    PrintWithStars('FoldIndexGrey Routine Called');    
    [cImageFolded{1} cVNCnPlain{1} sRescale{1} vILastXBlock] = FoldIndexGrey(...
        sImageApprox,varargin{:});
    
    % Required for spliting the indexes
    % < < - -
        vNRows = size(cImageFolded{1},1);
    % - - > > 
   
end
