function [ cFoldedImage, cVNCnPlain, cRescale, vILastXBlock ] = FoldIndexRGB(sImageApprox,...
    varargin)

% Folds supplied the three plains of supplied indexes into images generated ...
% using a constant atom.
%   Performed by recursivly calling FoldIndexGrey

% PrintWithStars([mfilename ,' Routine Called']);

% Check their are 3 index plains
% < < - - #
    nColours = numel(sImageApprox.cIndex);
    if nColours ~= 3
        error('Indexes should come from a seperatly processed RGB image!');
    end
% - - > > #

% Initialze the return structures
%   Place images one on top of each other in cell, cell2mat will then give
% place them one on top of the other.
    cFoldedImage = cell(nColours,1);
    cVNCnPlain = cell(nColours,1);
    cRescale = cell(nColours,1);
    vILastXBlock = zeros(1,3);
% - - > > #
    
for iColour = 1:nColours
    
    % Set up structure for one plane of the image
    % < < - - #
        sImage.x = sImageApprox.x;
        sImage.y = sImageApprox.y;
        sImage.z = 1;
        sImage.cIndex = sImageApprox.cIndex{iColour};
        sImage.nCoefficients = sImageApprox.nCoefficients(iColour);
        sImage.nIndexes = sImageApprox.nIndexes(iColour);
        sImage.blockWidth = sImageApprox.blockWidth;
        sImage.blockHeight = sImageApprox.blockHeight;
        sImage.nYBlocks = sImageApprox.nYBlocks;
        sImage.nXBlocks = sImageApprox.nXBlocks;
        sImage.maxIntensity = sImageApprox.maxIntensity;
    % - - > > #

    % Execute target function
        [cFoldedImage{iColour} cVNCnPlain{iColour} cRescale{iColour} ...
            vILastXBlock(iColour)] = FoldIndexGrey(sImage,varargin{:});        
    % - - > > #
    
    % Increment the public key
        varargin{2} = varargin{2} + 1;
    % - - > >
    
end