function [mImageToSave sImageApprox cImageFolded cIndexFolded vIXBlockEnd vIXBlockEndI] = ...
    Folding(sImageApprox,sApproxDetails,publicKey,privateKey,sBlockDims)

if nargin < 5
    % Default block processing dimentions
        sBlockDims.approxHeight = 8;
        sBlockDims.approxWidth = 8;
        sBlockDims.indexHeight = 8;
        sBlockDims.indexWidth = 8;
    % - - > > #
end


% Fixed params
    % Use rotation for the encryption operation
        rotate = 1;
    % - - > >
    
% - - > > #

% Set up the dictionary
    sDictionary = Dictionary(sApproxDetails.sDetails,...
        sBlockDims.approxHeight,1);
% - - > > #

% Fold the image
    [cImageFolded vNRowsImage vIXBlockEnd imageEmbedded imageHost] = ...
        FoldApprox(sImageApprox,sDictionary,sBlockDims,publicKey,privateKey,...
        rotate);
% - - > > #

% Fold the indexes
    [cIndexFolded cVNCnPlain sRescaleIndex vNRowsIndex vIXBlockEndI] = ...
        FoldIndex(sImageApprox,sBlockDims,publicKey,privateKey,rotate);
% - - > > #

% Fold vNCnPlain - ? What is required to recover

% Rescale all seperatly here

% Rescale mFoldedImage and mFoldedIndex to the range of alowable pixel
% intensities.
    maxIntensityToSave = 2^16-1;
    [cImageFolded,cIndexFolded,sRescaleImage] = RescaleForSave(...
        cImageFolded,cIndexFolded,maxIntensityToSave);
% - - > > #


% vAtom = ones(1,64)/norm(ones(1,64));
% c2 = cellfun(@(x) double(uint16(x)),cIndexFolded,'UniformOutput',0);
% [c1,c2] = RescaleFromSave(cImageFolded,c2,sRescaleImage,maxIntensityToSave);
% cIndexFolded = cellfun(@round,cIndexFolded,'UniformOutput',0);
%     [cImageR cImageIndexR] = RescaleFromSave(cImageFolded,cIndexFolded,...
%         sRescaleImage);

% Join mFoldedImage and mFoldedIndex 
%     mImageRescaled = [ mImageFolded; mIndexFolded ];
% - - > > #

% Remove rescaling 


% Calculate the mean intensity of the image
    meanIntensity = CellMean([cImageFolded,cIndexFolded]);
% - - > > #

% Rescale cVNCnPlain
    % Add the mean of existing image check less than maxIntensityToSave
    % ????
%     currentMean = cellfun(@mean(x(:)),cImageFolded,'UniformOutPut',0); 
%     currentMean = mean(cImageFolded{1}(:));
%     cVNCnPlain = cellfun(@(x) x+currentMean,cVNCnPlain,'UniformOutPut',0); 
    [cVNCnPlain adj]= MoveMean(cVNCnPlain,meanIntensity,0,maxIntensityToSave);
%     cVNCnPlain = RescaleCell(cVNCnPlain,0,maxIntensityToSave);
% - - > > #

% Include sRescaleNAtoms

% Place plain text values into a structure
    sPlainText = SPlainText(sImageApprox,sRescaleIndex,sRescaleImage,...
        vNRowsImage,vNRowsIndex);
% - - > > #
    

% Remove cVNCnPlain from this

% Place plain text and rescaling parameters into a vector
    vPlainText = SPlainTextF(sPlainText,cVNCnPlain,maxIntensityToSave);
% - - > > #    

% Scale the plain text vector to the image range
%     [vPlainText oldMin oldMax] = Rescale(vPlainText,0,maxIntensityToSave);
    % Have to store these as plain text,  does it make sense to change
    % this. - - Easily just add to the end of plain text and remove
% - - > > #

% Include cNAtomsFolded in the reshaper operation

% Reshape the image including the plain text params
    mImageToSave = ReshapeF(sImageApprox.z,cImageFolded,cIndexFolded,...
        sBlockDims.approxWidth,sBlockDims.approxHeight,vPlainText,...
        maxIntensityToSave,sImageApprox.approxType,adj,meanIntensity,...
        vIXBlockEnd,vIXBlockEndI);
% - - > > #

% Round the image to integer pixel intensity values