function sImage = LoadSImage(imagePath)

% Loads an image from its path an populates an image structure.
%   Converts indexed images to RGB or grey.


% Load the image matrix
% < < - - #
    [mImage bitDepth colourType map] = LoadMImage(imagePath);
% - - > > #

% Populate sImage structure
% < < - - #
    sImage = SImage;
    [sImage.y sImage.x sImage.z] = size(mImage);
    sImage.bitDepth = bitDepth;
    sImage.actualBitDepth = ApproxBitdepth(mImage);
    sImage.path = imagePath;
    sImage.mImage = mImage;
    sImage.maxIntensity =  (2^sImage.actualBitDepth)-1;
    if strcmp('colourType','indexed')
        sImage.map = map;
    end
    sImage.colourType = colourType;
% - - > > #