function [c adj] = MoveMean(c,newMean,m,M)

% Adjusts mean value of c to newMean and checks that the adjusted values
% lie between m and M.
% Assume m < newMean < M

% Get current min max and mean
    minC = min(cellfun(@(x) min(x(:)),c));
    maxC = max(cellfun(@(x) max(x(:)),c));
    meanC = CellMean(c);
% - - > > #

% Calculate amount to adjust
    % Adjustment has to be an integer
    adj = round(newMean - meanC);
    % If this adjustment moves the mean outside the desired range use the
    % maximum value availiable.
    if adj + maxC > M
        adj = fix(M - maxC);
    elseif adj + minC < m
        adj = fix(m - minC);
    end
    
% - - > > #

% Adjust the mean and return the adjustment
    c = cellfun(@(x) x+adj,c,'UniformOutput',0);
% - - > > #