function [PSNR SSIM] = PrintPSNRSSIM(m1,m2,maxIntensity)

% Calculates and prints out the PSNR and SSIM index

PSNR = CalcPSNR(m1,m2,maxIntensity);
% Use default values for SSIM
    K = [0.01 0.03];
    window = fspecial('gaussian', 11, 1.5);
% - - > > 

% Convert rgb to grey for calc of SSIM
    if size(m1,3) == 3
        SSIM = ssim(double(rgb2gray(uint16(m1))),...
            double(rgb2gray(uint16(m2))),K,window,maxIntensity);
    else
        SSIM = ssim(m1,m2,K,window,maxIntensity);
    end
% - - > > #

fprintf('PSNR: %5.2fdB SSIM: %5.3f\n',PSNR,SSIM);