function [m intMin intRange] = RescaleIntF(m,maxT)

% Rescales m to 0 < m < maxT where the scaling factor and constant
% adjustment are calculated using integers.
% The scaling is not optimum, useful if the original min and max values
% are double.

intMin = floor(min(m(:)));
intMax = ceil(max(m(:)));
intRange = intMax - intMin;

% Min value of m as close to zero from above as possible
    m = m - intMin;

% Scale keeping max value of m less than maxT
    m = m*maxT/intRange;