function sPlainText = SPlainTextE(vPlainText,approxType,mult)

iVPlainText = 1;
    
% Initialize params for all approx types
    sPlainText.maxIntensity = Mult(vPlainText(iVPlainText:iVPlainText+2),mult);
    iVPlainText = iVPlainText + 3;
    sPlainText.nYBlocks = Mult(vPlainText(iVPlainText:iVPlainText+2),mult);
    iVPlainText = iVPlainText + 3;
    sPlainText.nXBlocks = Mult(vPlainText(iVPlainText:iVPlainText+2),mult);
    iVPlainText = iVPlainText + 3;
% - - > > #

% RGB images processed 1 plain at a time will have 3 values for
%   nCoefficients
%   sRescaleIndex
%   vNRowImage
%   vNRowsIndex
    if approxType == 2
        nValues = 3;
    else
        nValues = 1;
    end
% - - > > #
    
% # of coefficients used
    for i = 1:nValues
        sPlainText.nCoefficients(i) = Mult(vPlainText(iVPlainText:iVPlainText+2)...
            ,mult);        
        iVPlainText = iVPlainText + 3;
    end
% - - > > #
        
% Rescaling applied to indexes or mNCnPerBlock
    for i = 1:nValues
        sPlainText.sRescaleIndex{i,1}.minV = Mult(vPlainText(iVPlainText:...
            iVPlainText+2),mult);
        iVPlainText = iVPlainText + 3;
        sPlainText.sRescaleIndex{i,1}.maxV = Mult(vPlainText(iVPlainText:...
            iVPlainText+2),mult);        
        iVPlainText = iVPlainText + 3;
         sPlainText.sRescaleIndex{i,1}.rescaled = Mult(vPlainText(iVPlainText:...
            iVPlainText+2),mult);        
        iVPlainText = iVPlainText + 3;       
    end
% - - > > # 
        
% # of rows for each folded image plain
    for i = 1:nValues
        sPlainText.vNRowsImage(i,1) = Mult(vPlainText(iVPlainText:iVPlainText+2),...
            mult);
        iVPlainText = iVPlainText + 3;
    end
% - - > > #

% # of rows for each folded index plain
    for i = 1:nValues
        sPlainText.vNRowsIndex(i,1) = Mult(vPlainText(iVPlainText:iVPlainText+2),...
            mult);
        iVPlainText = iVPlainText + 3;
    end    
% - - > > #

% Rescaling applied to the image before saving

    %   If RGB image will have 3 values for sRescaleImage.minM1 and 
    % sRescaleImage.maxM1.
    if approxType == 1
        nScales = 1;
    else
        nScales = 3;
    end
    
    for i = 1:nScales
        
        sPlainText.sRescaleImage.minM1{i} = Mult(vPlainText(iVPlainText:...
            iVPlainText+2),mult);
        iVPlainText = iVPlainText + 3;   
        sPlainText.sRescaleImage.maxM1{i} = Mult(vPlainText(iVPlainText:...
             iVPlainText+2),mult);
        iVPlainText = iVPlainText + 3;           
        
    end

    for i = 1:nValues
        sPlainText.sRescaleImage.minM2{i} = Mult(vPlainText(iVPlainText:iVPlainText+2),...
                mult);
        iVPlainText = iVPlainText + 3;     
        sPlainText.sRescaleImage.maxM2{i} = Mult(vPlainText(iVPlainText:iVPlainText+2),...
                mult);
        iVPlainText = iVPlainText + 3;    
    end
% - - > > #
    
end


function val = Mult(vVal,mult)
    
    % Expands the sign mult and diff values in v

    % Get the sign
        valSign = 1;
        if vVal(1) == 0
            valSign = -1;
        end
    % - - > > #
    
    % Expand the variable
        val = valSign * (vVal(2)*mult + vVal(3));
    % - - > > #
    
end
    
