function vPlainText = SPlainTextF(sPlainText,cVNCnPlain,maxVal)

% If RGB image will have 3 values for sRescaleImage.minM1 and
% sRescaleImage.maxM1.

iVPlainText = 1;
vPlainText = zeros(1,100);

% Initialize params for all approx types
    vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
        sPlainText.maxIntensity,maxVal);
    iVPlainText = iVPlainText + 3;
    vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
        sPlainText.nYBlocks,maxVal);
    iVPlainText = iVPlainText + 3;    
    vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
        sPlainText.nXBlocks,maxVal);
    iVPlainText = iVPlainText + 3;
% - - > > #

% RGB images processed 1 plain at a time will have 3 values for
%   nCoefficients
%   sRescaleIndex
%   vNRowImage
%   vNRowsIndex
%   minM2
%   maxM2
    nValues = numel(sPlainText.nCoefficients);
% - - > > #

% # of coefficients used
    for i = 1:nValues
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.nCoefficients(i),maxVal);       
        iVPlainText = iVPlainText + 3;
    end
% - - > > #        
        
% Rescaling applied to indexes or mNCnPerBlock
    for i = 1:nValues
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.sRescaleIndex{i,1}.minV,maxVal);       
        iVPlainText = iVPlainText + 3;
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.sRescaleIndex{i,1}.maxV,maxVal);       
        iVPlainText = iVPlainText + 3;       
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.sRescaleIndex{i,1}.rescaled,maxVal);       
        iVPlainText = iVPlainText + 3;        
    end
% - - > > #
        
% # of rows for each folded image plain
    for i = 1:nValues
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.vNRowsImage(i,1),maxVal);       
        iVPlainText = iVPlainText + 3;         
    end
% - - > > #

% # of rows for each folded index plain
    for i = 1:nValues
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.vNRowsIndex(i,1),maxVal);       
        iVPlainText = iVPlainText + 3;         
    end
% - - > > #        


% Rescaling applied to the image before saving

    %   If RGB image will have 3 values for sRescaleImage.minM1 and 
    % sRescaleImage.maxM1.
    nScales = numel(sPlainText.sRescaleImage.minM1);

    for i = 1:nScales
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.sRescaleImage.minM1{i},maxVal);       
        iVPlainText = iVPlainText + 3;
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.sRescaleImage.maxM1{i},maxVal);       
        iVPlainText = iVPlainText + 3; 
    end
    
    % If Ml or grey will have 1 scaling for indexes otherwise 3
    for i = 1:nValues
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.sRescaleImage.minM2{i},maxVal);        
        iVPlainText = iVPlainText + 3;  
        vPlainText(iVPlainText:iVPlainText+2) = SplitForSave(...
            sPlainText.sRescaleImage.maxM2{i},maxVal);       
        iVPlainText = iVPlainText + 3;         
    end
% - - > > #
    
% Reduce the size of vPlainText
    vPlainText = vPlainText(1:iVPlainText-1);
% - - > > #

% Add the vectors in cNCnPlain to the end of vPlainText
% <<--
    for i = 1:numel(cVNCnPlain)
        vPlainText = [vPlainText,cVNCnPlain{i}'];
    end
% -->>

end

function v = SplitForSave(val,maxVal)

    v = zeros(1,3);
    [mult diff] = Reduce(val,maxVal);
    v(1) = GetSign(val);
    v(2) = mult;
    v(3) = diff;    
    
end

function [mult diff] = Reduce(n,sz)

    % Reduct n to multiples of size plus a difference so n can be recovered
    % as n = mult*size + diff;
    
    % n has to be an absolute value
        n = abs(n);
    % - - > > #
    
    mult = fix(n/sz);
    diff = n - mult*sz;

end

function signFlag = GetSign(n)

    % Returns a 1 if positive and a 0 if negative
    signFlag = (n >= 0);

end    
