#ifndef MY_BLAS_H
#define MY_BLAS_H

#include "my_types.h"

void MatrixVectorMultBLAS(dbl *matrix, dbl *vector, dbl *returnVector, 
	ulng nRows, ulng nColumns, dbl alpha, dbl beta, char chn);

void ScaleVectorBLAS(dbl *v1, dbl alpha, ulng szVector);

dbl NormBLAS(dbl *atom, ulng szVector, ulng incx = 1);

dbl InnerProductBLAS(dbl *v1, dbl *v2,  ulng m, 
	ulng incx = 1, ulng incy = 1);

void AddVectorsBLAS(dbl *v1, dbl *v2, dbl alpha, ulng m, 
	ulng incx, ulng incy );

void MatrixMatrixMultBLAS(double *m1, double *m2, double *mReturn, 
	unsigned long m, unsigned long n,unsigned long k, char chn1, 
	char chn2, double alpha, double beta );

ulng MaxAbsBLAS(double *v, unsigned long m);

void OuterBLAS(double *m1, double *v1, double *v2, double alpha, 
	unsigned long m, unsigned long n);

#endif