% Compile_OMP2D Script to compile the OMP2D.cpp file and copy it to the Approximation\_Routines directory.

% First make sure we are in the correct directory;
functionName = mfilename;
functionPath = which(functionName);
functionPath = functionPath(1:end-(numel(functionName)+2));
pwdStore = pwd;
cd(functionPath);
if ~exist('Mex','dir')
    mkdir('Mex');
end
delete Mex/*
% Compile the mex file

% Force compile of header implementations

% Functions that interface with MATLAB
mex -c  COMPFLAGS="$COMPFLAGS /W4 -pg -O3" -outdir ../Common/MATLAB ...
    ../Common/MATLAB/get_input.cpp ../Common/MATLAB/get_matlab.cpp ...
    ../Common/MATLAB/set_matlab.cpp -I../Common

% Matrix operations
mex -c -largeArrayDims COMPFLAGS="$COMPFLAGS /W4 -O3" -outdir ../Common/Matrix...
    ../Common/Matrix/matrix_operations.cpp ../Common/Matrix/my_blas.cpp ...
    ../Common/Matrix/my_lapack.cpp -I../Common/ 

% Pursuit funcitons
mex -c COMPFLAGS="$COMPFLAGS /W4 -O3" -outdir ../Common/Helper/ ...
    ../Common/Helper/pursuit_functions.cpp -I../Common/ -I../Common/Matrix

% Functions from OMP
mex -c COMPFLAGS="$COMPFLAGS /W4 -O3" -outdir ../OMP/Source ...
    ../OMP/Source/OMP_Funs.cpp  -I../Common -I../Common/Matrix

% Functions from OMPMl
mex -c COMPFLAGS="$COMPFLAGS /W4 -O3" -outdir Source Source/OMPMlSep_Funs.cpp ...
    Source/OMPMlSep.cpp -I../Common -I../OMP/Source -I../Common/Matrix -I../Common/Helper

% Main routine
mex -c COMPFLAGS="$COMPFLAGS /W4 -O3" Source/OMPMlSep_Mex.cpp -outdir Source ...
    -I../Common/MATLAB -I../Common/Matrix -I../Common

% Compile and line
if ispc
    mex -largeArrayDims COMPFLAGS="$COMPFLAGS /W4 -O3" Source/OMPMlSep_Mex.obj Source/OMPMlSep_Funs.obj ...
        Source/OMPMlSep.obj ../OMP/Source/OMP_Funs.obj ../Common/Matrix/matrix_operations.obj ...
        ../Common/MATLAB/*.obj ../Common/Helper/pursuit_functions.obj ../Common/Matrix/my_blas.obj ...
        -outdir Mex/ -lmwblas
elseif isunix
    mex -largeArrayDims -cxx  COMPFLAGS="$COMPFLAGS /W4 -O3"  Source/OMPMlSep_Mex.o Source/OMPMlSep_Funs.o ...
        Source/OMPMlSep.o ../OMP/Source/OMP_Funs.o ../Common/Matrix/matrix_operations.o ...
        ../Common/MATLAB/get_matlab.o ../Common/MATLAB/set_matlab.o ...
        ../Common/MATLAB/get_input.o ../Common/Helper/pursuit_functions.o ...
        ../Common/Matrix/my_blas.o ...
        -outdir Mex/ -lmwblas 
else
    error('Unsupported platform!');
end
    

% mex Source/ProjMP2D_Mex.cpp -outdir Mex/ -lmwlapack -lmwblas
% mex Source/SPMP2D_Mex.cpp -outdir Mex/ -lmwlapack -lmwblas
clear functions;
% copyfile('Mex/*','../All_Routines');
% Change back to the previous directory
cd(pwdStore);